/*******************************************************************************
compr.c
(w) Gerald Schlueter
*******************************************************************************/
#include "compr.h"

#define MAXGAP 255

int
Uncompress(unsigned char *inbuf, unsigned char *outbuf, int length)
{
	unsigned char *ib= inbuf;
	unsigned char *ob= outbuf;
	int i;
	char *cnt;

	while (ib < inbuf + length) {
		cnt= ib++;
		for (i= 0; i < *cnt; i++) {
			*ob++= *ib++;
		}
		if(ib >= inbuf + length)
			return ob - outbuf;
		for(i= 0; i < *ib; i++)
			*ob++= '\0';
		ib++;
	}
	return ob - outbuf;
}

int
Compress(unsigned char *inbuf, unsigned char *outbuf,int length)
{
	int mode= 2;		/* 0= Nullen lesen 1= 1. Null 2= Text lesen */
	unsigned char *cnt=outbuf;	/* Position des Zhlers im outbuf */

	unsigned char *ib=inbuf;		/* Pointer im inbuf */
	unsigned char *ob=outbuf + 1;	/* Position im outbuf */

	*cnt= 0;	/* Zhler auf 0 */

	while(ib < inbuf + length) {
		/*
		 * Moduswechsel
		 */
		if(mode == 2 && !*ib)		/* Modus 2 -> Modus 1 */
			mode--;
		else if(mode == 1 && *ib)	/* Modus 1 -> Modus 2 */
			mode++;
		else if(mode == 1 && !*ib) {	/* Modus 1 -> Modus 0 */
			mode= 0;
			(*cnt)--;		/* Letzte 0 zurck */
			cnt= ob - 1;		/* Neuer Counter */
			*cnt= 2;		/* Zwei Nullen */
			ib++;
			continue;
		}
		else if(mode == 0 && *ib) {	/* Modus 0 -> Modus 2 */
			if(ob - outbuf >= length - 1)
				return length;
			mode= 2;
			cnt= ob++;		/* Neuer Counter */
			*cnt= 1;		/* 1 Zeichen */
			*ob= *ib;		/* Zeichen kopieren */
			ob++;			/* Next in, next out */
			ib++;
			continue;
		}

		/*
		 * Zu lange Sequenz?
		 */
		if(*cnt == MAXGAP) {
			if(ob - outbuf >= length - 1)
				return length;
			*ob= 0;
			ob++;
			cnt= ob;
			*cnt= 0;
			ob++;
		}

		/*
		 * bertragen
		 */
		if(mode) {
			if(ob - outbuf == length)
				return length;
			*ob= *ib;
			ob++;
		}

		/*
		 * Zhler
		 */
		(*cnt)++;
		ib++;
	}
	return ob - outbuf;
}
